/* $Filename:    WormWars/Source/engine.h $
 * $VER:         WormWars 5.21 $
 * $Description: Constants for game engine $
 *
 *  Copyright 2000 James R. Jacobs.
 */

#define GOATMOVE			 5		// assert (GOATMOVE != 0);
#define NOSE				 2		// if (NOSE > PROTECTORS) nose disabled
#define NOSEDISTANCE		 4
#define QUEUELIMIT			15
#define SECONDSPERLEVEL		120		// assert (SECONDSPERLEVEL <= 599);

#define FREQ_BONUS			 3
#define FREQ_MAX			40
#define FREQ_DEC			 3
#define FREQ_MIN			 8

#define BONUSDRIPSPEED		11
#define BONUSFRAGSPEED		 9
#define BONUSMISSILESPEED	 9
#define DRIPSPEED			13
#define FRAGSPEED			10
#define GOATSPEED			19
#define MISSILESPEED		12
#define PENGUINSPEED		23
#define ORBSPEED			11

// population limits

#define CREATURES           60
#define PROTECTORS			 2	// <=4!
#define TIMEBOMBS			 3

// vampirism

#define GOATBLOOD			1
#define ORBBLOOD			1
#define PENGUINBLOOD        1

// jump distances

#define FASTDISTANCE		5
#define NORMALDISTANCE		4
#define SLOWDISTANCE		3

// skill points

#define EMPTYPOINT		   1
#define TAILBONUS		   1
#define TURNTOSILVER	   5
#define TURNTOGOLD		  10
#define SILVERPOINT		  10
#define TIMEBONUS		  10
#define TELPOINT		  40
#define GOLDPOINT		  20
#define HITSHOT			  50
#define KILLGOAT          50
#define KILLPENGUIN       50
#define KILLWORM		 100
#define BOMBOVEREDGE	 100
#define SKULLPOINT		 100
#define YOURLETTER		 100
#define DRIPBONUS		 100
#define LEVELBONUS		 100
#define MYLETTER		 200

// pain ratings

#define DRIPPAIN		5
#define HEADPAIN		5
#define MISSILEPAIN		5
#define ORBPAIN			5
#define PROTECTORPAIN	5
#define REMNANTPAIN		5
#define TELEPORTPAIN	5
#define WORMFIREPAIN	5

#define FRAGMENTPAIN	3
#define OTHERTAILPAIN	3
#define LIGHTNINGPAIN	3
#define PENGUINPAIN     3
#define BOMBPAIN		3
#define PENGUINPAIN		3

#define SLIMEPAIN		2
#define GOATPAIN		2
#define SLAYERPAIN		2
#define METALPAIN		2

#define WOODPAIN		1
#define TAILPAIN		1
#define STONEPAIN		1

// objects

#define BOMBADD			 5	// in squares radius
#define BOMBRAND		25
#define CLOCKADD		10	// in seconds
#define CLOCKRAND		20
#define ICEADD			 5	// in VERYSLOWs
#define ICERAND			 5
#define MODEADD			30	// in VERYSLOWs
#define MODERAND		40
#define TREASUREADD		 5	// in seconds
#define TREASURERAND	 5

// Must have blank line at EOF.
