/* $Filename:    WormWars/Source/same.h $
 * $VER:         WormWars 5.21 $
 * $Description: Header file for Worm Wars $
 *
 *  Copyright 2000 James R. Jacobs.

SAME ON EACH PLATFORM -------------------------------------------------- */

#define elif				else if

// miscellaneous

#define CAUSEWAIT			  80
#define DATELENGTH			   8				// DD/MM/YY
#define TIMELENGTH			   5				// HH:MM
#define DEFAULTLEVELS		   5
#define ENDXPIXEL			((STARTXPIXEL + SQUAREX * (FIELDX + 1)) - 1)
#define ENDYPIXEL			((STARTYPIXEL + SQUAREY * (FIELDY + 1)) - 1)
#define FIELDX				  52				// in squares
#define FIELDY				  38				// in squares
#define HISCORES			   4
#define ILLEGAL				((APTR) 0xA9A9)		// debugging value
#define LIFEMODULO			1000
#define MAXLEVELS			  40				// assert (MAXLEVELS >= 1 && MAXLEVELS <= 99);
#define NAMELENGTH			  21				// 0..20 are TEXT, 21 is NULL
#define NUMKEYS				  28
#define PATIENCE			  20
#define SAYLIMIT			((ENDXPIXEL - STARTXPIXEL) / FONTX)
#define VERSION				"$VER: Worm Wars 5.21 (5.1.00) $"

// samples

#define FXGOATFIRE       0
#define FXPROTECTORBORN	 1
#define FXTIMEBOMBTICK	 2
#define FXGETGROWER		 3
#define FXMISSILEACTIVE	 4
#define FXGETPOWERUP	 5
#define FXUSETELEPORT	 6
#define FXWORMDEATH		 7
#define FXGETAMMO		 8
#define FXEXPLODE		 9
#define FXGOATBORN      10
#define FXORBBORN		11
#define FXSHOOT			12
#define FXTITLESCREEN	13
#define FXVICTORY		14
#define FXFILENEW		15
#define FXFILEOPEN		16
#define FXFILESAVE		17
#define FXBOMBBLAST		18
#define FXDEFEAT		19
#define FXENDOFLEVEL	20
#define FXCLICK			21
#define FXUSEARMOUR		22
#define FXGETOBJECT		23
#define FXTIMEALERT		24
#define FXORBSPLIT		25
#define FXORBDEATH      26
#define FXFILESAVEAS	27
#define FXFX			28
#define FXGETNITRO		29
#define FXJUMP			30
#define FX_C			31
#define FX_O			32
#define FX_M			33
#define FX_P			34
#define FX_L			35
#define FX_E			36
#define FX_T			37
#define FXHISCORE		38
#define FXTHUD			39
#define FXGOATDEATH     40
#define FXGETSKULL		41
#define FXUSETONGUE		42
#define FXDRIPBORN		43
#define FXAMIGAN		44
#define FXPAIN			45
#define FXPENGUINBORN	49
#define FXPENGUINDEATH	50
#define FXRUNDOWN		51
#define FXEDITCUT		52
#define FXEDITCOPY		53
#define FXEDITPASTE		54
#define FXLEVELDELETE		55
#define SAMPLES			55

#define FXSTAMPED		FXBOMBBLAST
#define FXUSEPROTECTOR  FXPROTECTORBORN
#define FXDRIP			FXFX

// frequencies

#define  DRIPFREQ_MAX       30     // starting frequency (level 0)
#define  DRIPFREQ_DEC        2     // minus level * DRIPDECREASE
#define  DRIPFREQ_MIN       10     // but always at least DRIPFREQ_MIN
#define  GOATFREQ_MAX      120
#define  GOATFREQ_DEC        5
#define  GOATFREQ_MIN       20
#define   ORBFREQ_MAX      220
#define   ORBFREQ_DEC       10
#define   ORBFREQ_MIN       20
#define SLIMEFREQ_MAX      200
#define SLIMEFREQ_DEC       30
#define SLIMEFREQ_MIN       50

#define TELFREQ            240

// key types

#define MOVE				  0	// not AMMO, TRAINER, ONEHUMAN
#define TRAINER				  2	// not MOVE, AMMO, ONEHUMAN
#define ONEHUMAN			  3	// not MOVE, AMMO, TRAINER

// speeds

#define VERYFAST    	         1
#define FAST        	         2
#define NORMAL      	         4
#define SLOW        	         8
#define VERYSLOW                16      // must be non-0

/* The constant NORMAL is used for several purposes:
	a)	as a speed (therefore must not be VERYFAST, FAST, SLOW
			or VERYSLOW);
	b)	as a blitmode (therefore must not be BLACK or WHITE); and
	c)	as a pointer (therefore must not be GOLD, SILVER, EMPTY,
			WOOD or STONE).

stats */

#define AMMOLIMIT	   100
#define BIASLIMIT	   100
#define STARTLIVES	   100
#define LIVESLIMIT	   200
#define MODELIMIT	   100
#define MULTILIMIT       8      // don't set >8!
#define POWERLIMIT	     6
#define SCORELIMIT	999999L

/* Field values...
These are objects. */
	#define AFFIXER				 0
	#define AMMO				 1
	#define ARMOUR				 2
	#define BIAS				 3
	#define BOMB				 4
	#define BONUS				 5
	#define CLOCK				 6
	#define GROWER				 7
	#define HEALER				 8
	#define ICE					 9
	#define LIFE				10
	#define LIGHTNING			11
	#define MISSILE				12
	#define MULTIPLIER			13
	#define NITRO				14
	#define POWER				15
	#define PROTECTOR			16
	#define PULSE				17
	#define REMNANTS			18
	#define SLAYER				19
	#define SLOWER				20
	#define SWITCHER			21
	#define TONGUE				22
	#define TREASURE			23
	#define UMBRELLA			24
	#define LASTOBJECT			UMBRELLA
// These are `empty'.
	#define EMPTY				(LASTOBJECT + 1)
	#define SILVER				(LASTOBJECT + 2)
	#define GOLD				(LASTOBJECT + 3)
	#define FIRSTEMPTY			EMPTY
	#define LASTEMPTY			GOLD
	#define LASTGOATFIRE		LASTEMPTY
// Nothing special about the following...
	#define TELEPORT			(GOLD + 1)
	#define FRAGMENT			(GOLD + 2)
	#define ORB					(GOLD + 3)
	#define FIRSTPROTECTOR		(GOLD + 4)
	#define LASTPROTECTOR		(GOLD + 7)
/* Margins indicate `ranges' for:
	l:	letters.
	n:	orb bouncing, normal mode.
	t:	orb bouncing, tongue mode.
	a:	orb bouncing, armour mode.
	k:	killers.								   l n t a k */
	#define  GREEN_C			(GOLD +  8)		// [       
	#define    RED_O			(GOLD +  9)		// |       
	#define   BLUE_M			(GOLD + 10)		// |       
	#define YELLOW_P			(GOLD + 11)		// |       
	#define  GREEN_L			(GOLD + 12)		// |       
	#define    RED_E			(GOLD + 13)		// |       
	#define   BLUE_T			(GOLD + 14)		// |       
	#define YELLOW_E			(GOLD + 15)		// ]       
	#define SKULL				(GOLD + 16)		//         
    #define SLIME				(GOLD + 17)		//       [ [
	#define STONE				(GOLD + 18)		//   [ [ | |
	#define GOAT    			(GOLD + 19)		//   ] | | |
	#define WOOD				(GOLD + 20)		//     | ] |
	#define FIRSTTAIL			(GOLD + 21)		//     |   |
	#define LASTTAIL			(GOLD + 24)		//     ]   ]
	#define FIRSTLETTER			GREEN_C
	#define FIRSTNONE			STONE
	#define FIRSTTONGUE			STONE
	#define FIRSTARMOUR			SLIME
    #define FIRSTGOAT           SLIME
	#define LASTLETTER			YELLOW_E
	#define LASTNONE			LASTTAIL
	#define LASTTONGUE			GOAT
	#define LASTARMOUR			GOAT
	#define LASTGOAT			LASTTAIL
	#define LETTERS				(LASTLETTER - FIRSTLETTER)

/* These are never part of the field[][] or board[][][] arrays
(except METAL) */
	#define ORBTONGUE			(LASTTAIL +  1)
	#define ORBARMOUR			(LASTTAIL +  2)
	#define FIRSTFIRE			(LASTTAIL +  3)
	#define LASTFIRE			(LASTTAIL +  6)
	#define FIRSTMISSILE		(LASTTAIL +  7)
	#define LASTMISSILE			(LASTTAIL + 10)
	#define START				(LASTTAIL + 11)
	#define MUSIC				(LASTTAIL + 12)
	#define STICKY				(LASTTAIL + 13)
	#define FX					(LASTTAIL + 14)
	#define ZERO				(LASTTAIL + 15)
	#define ONE					(ZERO + 1)
	#define TWO					(ZERO + 2)
	#define       HEAD			(ZERO + 10)
	#define  GREENHEADUP		 HEAD
	#define    REDHEADUP		(HEAD +  1)
	#define   BLUEHEADUP		(HEAD +  2)
	#define YELLOWHEADUP		(HEAD +  3)
	#define  FIRSTHEAD			GREENHEADUP
	#define   LASTHEAD			YELLOWHEADUP
	#define  GREENHEADDOWN		(HEAD +  4)
	#define    REDHEADDOWN		(HEAD +  5)
	#define   BLUEHEADDOWN		(HEAD +  6)
	#define YELLOWHEADDOWN		(HEAD +  7)
	#define  GREENHEADLEFT		(HEAD +  8)
	#define    REDHEADLEFT		(HEAD +  9)
	#define   BLUEHEADLEFT		(HEAD + 10)
	#define YELLOWHEADLEFT		(HEAD + 11)
	#define  GREENHEADRIGHT		(HEAD + 12)
	#define    REDHEADRIGHT		(HEAD + 13)
	#define   BLUEHEADRIGHT		(HEAD + 14)
	#define YELLOWHEADRIGHT		(HEAD + 15)
	#define  GREENMODEUP		(HEAD + 16)
	#define    REDMODEUP		(HEAD + 17)
	#define   BLUEMODEUP		(HEAD + 18)
	#define YELLOWMODEUP		(HEAD + 19)
	#define  GREENMODEDOWN		(HEAD + 20)
	#define    REDMODEDOWN		(HEAD + 21)
	#define   BLUEMODEDOWN		(HEAD + 22)
	#define YELLOWMODEDOWN		(HEAD + 23)
	#define  GREENMODELEFT		(HEAD + 24)
	#define    REDMODELEFT		(HEAD + 25)
	#define   BLUEMODELEFT		(HEAD + 26)
	#define YELLOWMODELEFT		(HEAD + 27)
	#define  GREENMODERIGHT		(HEAD + 28)
	#define    REDMODERIGHT		(HEAD + 29)
	#define   BLUEMODERIGHT		(HEAD + 30)
	#define YELLOWMODERIGHT		(HEAD + 31)
	#define METAL				(HEAD + 32)
	#define FIRSTDRIP			(HEAD + 33)
	#define DRIP				FIRSTDRIP
	#define LASTDRIP			(HEAD + 36)
	#define BLACKENED			(HEAD + 37)
	#define WHITENED			(HEAD + 38)
	#define PENGUIN				(HEAD + 39)
	#define ARRAYSIZE			PENGUIN

	#define ANYTHING			FX

// These have no imagery.
	#define TEMPTAIL			(ARRAYSIZE + 1)
	#define TEMPWOOD			TEMPTAIL
	#define TEMPSLIME			TEMPTAIL
	#define TEMPSILVER			(ARRAYSIZE + 2)
	#define TEMPGOLD			(ARRAYSIZE + 3)
	#define NOSQUARE			(ARRAYSIZE + 4)

// game status

#define GAMEOVER        0
#define PLAYGAME        1
#define FIELDEDIT		2
#define TITLESCREEN		3

// indicator locations

#define CAUSEYDISTANCE	2	// distance from centre for cause
#define LETTERYDISTANCE	3	// distance from centre for letters
#define ICONY			(FIELDY / 2)
#define MUSICICON		(FIELDX + 2)
#define CLOCKICON		(FIELDX + 5)
#define STICKYICON		(FIELDX + 8)

// control values

#define NONE            0   // must be 0
#define AMIGA           1
#define HUMAN           2
#define IBMPC			AMIGA

/* PROTOTYPES -------------------------------------------------------------

engine.c(pp) */

void change(SBYTE x, SBYTE y, UBYTE image);
void changefield(void);
void clearhiscores(void);
void clearletters(void);
void death(void);
void enginesetup(void);				// once-only initialization of engine variables
void fastloop(void);				// things done often
void gameloop(void);
void killall(void);
void levelappend(void);				// Level|Append function
void leveldelete(void);				// Level|Delete function
void levelerase(void);				// Level|Erase function
void levelinsert(void);				// Level|Insert function
void playmusic(void);
void matchteleports(void);
void missileloop(void);				// controls missiles
void newfield(void);
void newfields(void);
void newgame(void);
void newhiscores(void);
void orientworms(void);
void slowloop(void);				// things done rarely
void stopmusic(void);
void timeloop(void);

void align(STRPTR string, SBYTE size, TEXT filler);
									// right-justify a string within another string
void bombblast(SBYTE triggerer, SBYTE player, SBYTE centrex, SBYTE centrey);
void bouncekiller(SBYTE which, SBYTE x, SBYTE y);
void copyfield(SBYTE source, SBYTE destination);
void createmissile(UBYTE player);
void creatureloop(SBYTE which);
void drawcause(SBYTE player, SBYTE state);
void drawletter(SBYTE player, SBYTE letter, SBYTE state);
void explosion(SBYTE x, SBYTE y, SBYTE exceptionx, SBYTE exceptiony);
void fillfield(SBYTE which);
void newlevel(SBYTE player);
void orbscore(SBYTE which, ULONG score);
void orbsplit(SBYTE which);
void putletter(SBYTE player);
void queue(SBYTE player, SBYTE deltax, SBYTE deltay);
void ramming(SBYTE player);
void reflect(UBYTE which);
void saylevel(COLOUR colour);
void setbrush(SBYTE newbrush);
void train(SCANCODE scancode);
void turnworm(SBYTE player, SBYTE deltax, SBYTE deltay);
void updatesquare(SBYTE x, SBYTE y);
void whichfrag(SBYTE x, SBYTE y, SBYTE* whichptr, SBYTE* iwhichptr);
void wormbullet(SBYTE player);
void wormletter(SBYTE player, SBYTE thissy);
void wormloop(SBYTE player);			// controls worms and protectors
void wormscore(SBYTE player, LONG score);

SWORD atleast(SWORD value, SWORD minimum);
ABOOL blocked(SBYTE which, SBYTE deltax, SBYTE deltay);
ABOOL bounceorb(SBYTE which, SBYTE x, SBYTE y);
SBYTE bsign(SBYTE value);
ABOOL findempty(SBYTE* x, SBYTE* y, SBYTE first, SBYTE last);
SBYTE loadfields(STRPTR pathname);
SBYTE onlyworm(ABOOL alive);
SBYTE partner(SBYTE which);
ABOOL savefields(STRPTR pathname);
SBYTE slowdown(SBYTE speed);		// halve worm's speed
SBYTE speedup(SBYTE speed, ABOOL nitro);
ULONG squareblast(SBYTE type, SBYTE player, SBYTE thissy, SBYTE x, SBYTE y);
SBYTE valid(SBYTE x, SBYTE y);
UBYTE whichcreature(SBYTE x, SBYTE y, UBYTE species, UBYTE exception);
SBYTE whichteleport(SBYTE x, SBYTE y);
SBYTE whichtimebomb(SBYTE x, SBYTE y);
SWORD wsign(SWORD value);
SBYTE xwrap(SBYTE x);
SBYTE ywrap(SBYTE y);

// system.c(pp)

void celebrate(void);
void clearjoystick(void);
void clearkybd(void);
void clearscreen(void);
void datestamp(void);
void fileabout(void);				// File|About... function
void fileopen(void);				// File|Open... function
void freefx(void);
void gameinput(void);
void hiscores(void);
void loadthefx(void);
void loadthemusic(void);
void joy0(void);
void parsewb(void);
void pausetimer(void);
void resettime(void);
void sendreadrequest(void);
void systemsetup(void);
void timing(void);
void titlescreen(void);				// the title screen
void turborender(void);
void waitasec(void);
void unpausetimer(void);

void cleanexit(SLONG rc);
void dot(SBYTE x, SBYTE y);
void draw(SBYTE x, SBYTE y, SBYTE image);
void effect(SBYTE index);
void filesaveas(ABOOL flag);     	// File|Save, File|Save As... functions
void preserve(SWORD x, SBYTE row, SBYTE image, UWORD amount);
void rundown(SBYTE player);
void say(STRPTR sentence, COLOUR colour);
void setpointer(SBYTE brush);
void stat(SBYTE player, SBYTE line);
void stopfx(ULONG receipt);
void toggle(SBYTE key);
void underline(SBYTE brush);

ABOOL anykey(ABOOL timeout);
ABOOL beginfx(void);
UBYTE ReadJoystick(UWORD joynum);
ABOOL verify(void);
SWORD xpixeltosquare(SWORD x);
SWORD ypixeltosquare(SWORD y);
ABOOL ZOpen(STRPTR fieldname, ABOOL write);
ABOOL ZRead(STRPTR IOBuffer, ULONG length);
ABOOL ZWrite(STRPTR IOBuffer, ULONG length);
ABOOL ZClose(void);

// PUBLIC STRUCTURES ------------------------------------------------------

AGLOBAL struct HiScoreStruct
{	SBYTE	player,	level;
	SLONG	score;					// the score itself
	TEXT	name[NAMELENGTH + 2];	// name of the player
	ABOOL	fresh;					// is the entry new?
	TEXT	date[DATELENGTH + 1],	// date of achievement
			time[TIMELENGTH + 1];	// time of achievement
};
AGLOBAL struct TeleportStruct
{	SBYTE		x, y;
	ABOOL		alive;
};
AGLOBAL struct WormStruct
{   SBYTE       x, y, deltax, deltay, position, victor, cause,
                statx, staty, pos, multi, power, remnants, mode, last,
                levelreached;
	ABOOL		affixer, alive, moved, nitro;
	UBYTE		speed, control;
	SWORD		armour, tongue, ammo, bias, ice, lives;
	SLONG		score, oldscore, hiscore;
	ULONG		causewait;
	TEXT		name[NAMELENGTH + 1];
	COLOUR		colour;
};

// Must have blank line at EOF.
